#pragma once
#include <afxstr.h>
/******************************************************************************************
IMPORT
******************************************************************************************/
void UnloadDll();
BOOL LoadDll();

#ifdef __cplusplus
#define PRINTER_API extern "C" __declspec(dllimport)
#else
#define PRINTER_WIN32_SDK_API __declspec(dllimport)
#endif

typedef int(__stdcall *PrinterCreator)(void**, const char*);
typedef int(__stdcall *PrinterCreatorS)(char*);
typedef int(__stdcall *PortOpen)(void*, const char*);
typedef int(__stdcall *PortClose)(void*);
typedef int(__stdcall *PrinterDestroy)(void*);
typedef int(__stdcall *DirectIO)(void* handle, unsigned char writedata[], unsigned int writenum, unsigned char readdata[], unsigned int readnum, unsigned int* preadednum);
typedef int(__stdcall *CPCL_AddLabel)(void* , int , int , int );
typedef int(__stdcall *CPCL_SetAlign)(void* , int );
typedef int(__stdcall *CPCL_AddText)(void* , int , int , int , int , int , char*);
typedef int(__stdcall *CPCL_AddBarCode)(void* , int , int , int , int , int , int , int , const char* );
typedef int(__stdcall *CPCL_AddBarCodeText)(void* , int , int , int , int );
typedef int(__stdcall *CPCL_AddQRCode)(void* , int , int , int , int , int , int , const char* );
typedef int(__stdcall *CPCL_AddPDF417)(void* , int , int , int , int , int , int , int , int , const char* );
typedef int(__stdcall *CPCL_AddBox)(void* , int , int , int , int , int );
typedef int(__stdcall *CPCL_AddLine)(void* , int , int , int , int , int );
typedef int(__stdcall *CPCL_SetFontSize)(void* , int , int );
typedef int(__stdcall *CPCL_SetDensity)(void* , int );
typedef int(__stdcall *CPCL_SetSpeed)(void* , int );
typedef int(__stdcall *CPCL_SetTextSpacing)(void* , int );
typedef int(__stdcall *CPCL_SetTextBold)(void* , int );
typedef int(__stdcall *CPCL_SetTextUnderline)(void* , int );
typedef int(__stdcall *CPCL_Print)(void*);
typedef int(__stdcall *CPCL_NextLabelPos)(void* );
typedef int(__stdcall *CPCL_PreFeed)(void* , int );
typedef int(__stdcall *CPCL_PostFeed)(void* , int );

extern void* hprinter;

extern HMODULE m_Dll;

extern PrinterCreator                               DemoPrinterCreator;
extern PrinterCreatorS                              DemoPrinterCreatorS;
extern PrinterDestroy                               DemoPrinterDestroy;
extern PortOpen                                     DemoPortOpen;
extern PortClose                                    DemoPortClose;
extern DirectIO                                     DemoDirectIO;
extern CPCL_AddLabel                                AddLabel;
extern CPCL_SetAlign                                SetAlign;
extern CPCL_AddText                                 AddText;
extern CPCL_AddBarCode                              AddBarCode;
extern CPCL_AddBarCodeText                          AddBarCodeText;
extern CPCL_AddQRCode                               AddQRCode;
extern CPCL_AddPDF417                               AddPDF417;
extern CPCL_AddBox                                  AddBox;
extern CPCL_AddLine                                 AddLine;
extern CPCL_SetFontSize                             SetFontSize;
extern CPCL_SetDensity                              SetDensity;
extern CPCL_SetSpeed                                SetSpeed;
extern CPCL_SetTextSpacing                          SetTextSpacing;
extern CPCL_SetTextBold                             SetTextBold;
extern CPCL_SetTextUnderline                        SetTextUnderline;
extern CPCL_Print                                   LabelPrint;
extern CPCL_NextLabelPos                            NextLabelPos;
extern CPCL_PreFeed                                 PreFeed;
extern CPCL_PostFeed                                PostFeed;