#include"stdafx.h"
#include "printer_base.h"

PrinterCreator                               DemoPrinterCreator;
PrinterCreatorS                              DemoPrinterCreatorS;
PrinterDestroy                               DemoPrinterDestroy;
PortOpen                                     DemoPortOpen;
PortClose                                    DemoPortClose;
DirectIO                                     DemoDirectIO;
CPCL_AddLabel                                AddLabel;
CPCL_SetAlign                                SetAlign;
CPCL_AddText                                 AddText;
CPCL_AddBarCode                              AddBarCode;
CPCL_AddBarCodeText                          AddBarCodeText;
CPCL_AddQRCode                               AddQRCode;
CPCL_AddPDF417                               AddPDF417;
CPCL_AddBox                                  AddBox;
CPCL_AddLine                                 AddLine;
CPCL_SetFontSize                             SetFontSize;
CPCL_SetDensity                              SetDensity;
CPCL_SetSpeed                                SetSpeed;
CPCL_SetTextSpacing                          SetTextSpacing;
CPCL_SetTextBold                             SetTextBold;
CPCL_SetTextUnderline                        SetTextUnderline;
CPCL_Print                                   LabelPrint;
CPCL_NextLabelPos                            NextLabelPos;
CPCL_PreFeed                                 PreFeed;
CPCL_PostFeed                                PostFeed;

HMODULE m_hDll;
void* hprinter;

void UnloadDll()
{
	 FreeLibrary(m_hDll);
}
 BOOL LoadDll()
 {
	 m_hDll = LoadLibrary(_T("CPCL_SDK.dll"));
	 if (m_hDll == 0)
	 {
		 return FALSE;
	 }
	 else
	 {
		 DemoPrinterCreator = (PrinterCreator)GetProcAddress(m_hDll, "PrinterCreator");
		 DemoPrinterCreatorS = (PrinterCreatorS)GetProcAddress(m_hDll, "PrinterCreatorS");
		 DemoPrinterDestroy = (PrinterDestroy)GetProcAddress(m_hDll, "PrinterDestroy");
		 DemoPortOpen = (PortOpen)GetProcAddress(m_hDll, "PortOpen");
		 DemoPortClose = (PortClose)GetProcAddress(m_hDll, "PortClose");
		 DemoDirectIO = (DirectIO)GetProcAddress(m_hDll, "DirectIO");
		 AddLabel = (CPCL_AddLabel)GetProcAddress(m_hDll, "CPCL_AddLabel");
		 SetAlign = (CPCL_SetAlign)GetProcAddress(m_hDll, "CPCL_SetAlign");
		 AddText = (CPCL_AddText)GetProcAddress(m_hDll, "CPCL_AddText");
		 AddBarCode = (CPCL_AddBarCode)GetProcAddress(m_hDll, "CPCL_AddBarCode");
		 AddBarCodeText = (CPCL_AddBarCodeText)GetProcAddress(m_hDll, "CPCL_AddBarCodeText");
		 AddQRCode = (CPCL_AddQRCode)GetProcAddress(m_hDll, "CPCL_AddQRCode");
		 AddPDF417 = (CPCL_AddPDF417)GetProcAddress(m_hDll, "CPCL_AddPDF417");
		 AddBox = (CPCL_AddBox)GetProcAddress(m_hDll, "CPCL_AddBox");
		 AddLine = (CPCL_AddLine)GetProcAddress(m_hDll, "CPCL_AddLine");
		 SetFontSize = (CPCL_SetFontSize)GetProcAddress(m_hDll, "CPCL_SetFontSize");
		 SetDensity = (CPCL_SetDensity)GetProcAddress(m_hDll, "CPCL_SetDensity");
		 SetSpeed = (CPCL_SetSpeed)GetProcAddress(m_hDll, "CPCL_SetSpeed");
		 SetTextSpacing = (CPCL_SetTextSpacing)GetProcAddress(m_hDll, "CPCL_SetTextSpacing");
		 SetTextBold = (CPCL_SetTextBold)GetProcAddress(m_hDll, "CPCL_SetTextBold");
		 SetTextUnderline = (CPCL_SetTextUnderline)GetProcAddress(m_hDll, "CPCL_SetTextUnderline");
		 LabelPrint = (CPCL_Print)GetProcAddress(m_hDll, "CPCL_Print");
		 NextLabelPos = (CPCL_NextLabelPos)GetProcAddress(m_hDll, "CPCL_NextLabelPos");
		 PreFeed = (CPCL_PreFeed)GetProcAddress(m_hDll, "CPCL_PreFeed");
		 PostFeed = (CPCL_PostFeed)GetProcAddress(m_hDll, "CPCL_PostFeed");
		 return TRUE;
	 }
 }