﻿Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Text
Imports System.Windows.Forms
Imports System.Runtime.InteropServices
Imports System.IO.Ports
Imports System.Text.RegularExpressions
Imports VB_Demo.Printer
Public Class VB_CPCL
    Private printer As DemoPrinter = New DemoPrinter()
    Dim Result As Integer = 0
    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        Result = printer.DemoPrinterCreator("HM-A300")
        If Constants.E_SUCCESS = Result Then
            Result = printer.DemoPortOpen("USB")
            If Constants.E_SUCCESS = Result Then
                '设置标签大小和打印的数量
                Result = printer.AddLabel(0, 1100, 1)
                '打印文本
                Result = printer.AddText(0, 7, 3, 30, 10, "你好")
                Result = printer.AddText(0, 7, 2, 90, 10, "hello")
                Result = printer.AddText(0, 7, 2, 10, 40, "こんにちは")
                '注释条码
                Result = printer.AddBarCodeText(1, 7, 0, 5)
                '打印Code 128条码
                Result = printer.AddBarCode(0, 0, 1, 1, 50, 10, 80, "123456789")
                '打印Code 39条码
                Result = printer.AddBarCode(0, 5, 1, 1, 50, 10, 180, "66886868")
                '打印Code 93条码
                Result = printer.AddBarCode(0, 7, 1, 1, 50, 10, 280, "88886666")
                '打印EAN 13条码
                Result = printer.AddBarCode(0, 10, 1, 1, 50, 10, 380, "012345678901")
                '打印EAN 8条码
                Result = printer.AddBarCode(0, 13, 1, 1, 50, 10, 480, "1234567")
                '打印二维条码
                Result = printer.AddQRCode(0, 10, 580, 2, 6, 1, "1010011110")
                '打印PDF417二维条码
                Result = printer.AddPDF417(0, 10, 750, 2, 6, 8, 8, 1, "0010101101")
                '画框
                Result = printer.AddBox(10, 820, 40, 880, 1)
                '画线
                Result = printer.AddLine(10, 900, 80, 970, 3)
                '设置打印浓度
                Result = printer.SetDensity(3)
                '打印标签
                Result = printer.Print()
                '关闭端口
                Result = printer.DemoPortClose()
                '销毁
                Result = printer.DemoPrinterDestroy()
            Else
                MessageBox.Show("Usb Device not found.")
                Close()
            End If
        Else
            MessageBox.Show("Printer Device not found")
            Close()
        End If
    End Sub
End Class